"""xc URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/2.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import include, path

import login
import main

urlpatterns = [
    path('login/', include('login.urls', namespace='login')),
    path('register/', include('register.urls', namespace='register')),
    path('main/', include('main.urls', namespace='main')),
    path('msgs/', include('msgs.urls', namespace='msgs')),
    path('admin/', admin.site.urls),
    path('favicon.ico', login.views.favicon),
    path('', main.views.home),
]
